--[[
   Luaプログラム
   bhv_their_goal_kick_move.cppを実装している.
]]

--require("luaLib/Geom/Vector2D")
dofile("luaLib/Geom/Vector2D.lua")

local oppGoalKickMove = TheirGoalKickMove()

function TheirGoalKickMove_main()

    if (ChaseBall()) then
	return true
    end
    --仮設定
    --local interX = 40.0
    --local interY = 30.0
    
    --ボールの速度を確保
    velr = getBallVelR()
    if (velr > 0.2) then
	ret = oppGoalKickMove:their_penalty()
        if (ret) then
	   doNormal()
	   return true
	end
	inter = getVector2D()
        --interX = oppGoalKickMove:getInterX()
	--interY = oppGoalKickMove:getInterY()
        interX = inter[1]
	interY = inter[2]
    else
	ret = oppGoalKickMove:their_goal()
	if (ret) then
	   doNormal()
	   return true
	end
	interX = theirPenaltyAreaLineX() - 0.76
	interY = getBallPosY()
    end

   if (oppGoalKickMove:canIntersection(interX,interY)) then
	doNormal()
	return true
   end
   
   local dashPow = getSafetyDashPower(getMaxDashPower() * 0.8)
   --ボールとプレイヤーの位置でパラメータを変更する
   if(interX < theirPenaltyAreaLineX()
	and getSelfPosX() > theirPenaltyAreaLineX() - 0.5) then
	interY = penaltyAreaHalfWidth() - 0.5
        if(getSelfPosY() < 0.0) then interY = interY * -1.0 end
   elseif (interY > penaltyAreaHalfWidth()
	and getSelfPosAbsY() < penaltyAreaHalfWidth() + 0.5)then
	interY = penaltyAreaHalfWidth() + 0.5
        if (getSelfPosY()) then interY = interY * -1.0 end
   end

   local dist_thr = getBallDist() * 0.07
   if (dist_thr < 1.0) then dist_thr = 1.0 end

   if(not oppGoalKickMove:GoToIntersection(
	interX, interY, dist_thr, dashPow)) then
	Body_TurnToBall()
   end
   Neck_ScanField()
   return true
end

function doNormal()
   local dashpow = oppGoalKickMove:getDashPower()

   oppGoalKickMove:setTarget()
   --キーパーの状態確認
   oppGoalKickMove:attractBall()
   oppGoalKickMove:checkPenaltyArea()

   --ボールが近くにあるかどうか
   local dist_thr = getBallDist() * 0.07
   if (dist_thr < 1.0) then dist_thr = 1.0 end
   --目標地点まで歩く
   if(not oppGoalKickMove:
	GoToTarget(dist_thr, dashpow)) then
	Body_TurnToBall()
   end
   Neck_TurnToBallOrScan()
end

function ChaseBall()
   --セルフのサイクル
   local self_min = selfReachCycle()
   if (self_min > 10) then
	return false
   end

   local get_posX = getBallInertiaX(self_min)
   local get_posY = getBallInertiaY(self_min)

   local penX = theirPenaltyAreaLineX() - 1.0
   local penY = penaltyAreaHalfWidth() + 1.0

   --敵がペナルティエリアに入ったらfalse(ボールをとらえない)
   if (oppGoalKickMove:PenaltyContain(
	penX, -penY, get_posX, get_posY)) then
	return false
   end

   if (get_posX > penX 
	and getSelfPosX() < penX
	and getSelfPosAbsY() < penY - 0.5) then
	return false
   end   

   doIntercept()
   Neck_TurnToBallOrScan()
   return true
end
