--[[
   オブジェクト指向型プログラミング用
   Line2D.lua
]]
--[[require ("luaLib/Geom/Angle2D")
require ("luaLib/Geom/Vector2D_o")]]
dofile ("luaLib/Geom/Angle2D.lua")
dofile ("luaLib/Geom/Vector2D_o.lua")

local EPSILON = 1.0e-10
Line2D = {}
line2d_vec = Vector2D.new(0, 0)

--インスタンス生成
function Line2D.new(x, y, linedir)
  local a = -math.sin(DtoR(linedir)) 
  local	b = math.cos(DtoR(linedir)) 
  local c = -a * x - b * y

  local obj = {a,b,c}
  
  -- メタテーブルセット
  return setmetatable(obj, {__index = Line2D})
end

--インスタンス生成
function Line2D.new2(x1, y1, x2, y2)
  local a = -(y2 - y1)
  local	b = (x2 - x1) 
  local c = -a * x1 - b * y1

  local obj = {a,b,c}

  -- メタテーブルセット
  return setmetatable(obj, {__index = Line2D})
end

function Line2D.set_Line2D2(self, x1, y1, x2, y2)
  self.a = -(y2 - y1)
  self.b = (x2 - x1)
  self.c = -self.a * x1 - self.b * y1
  --print(self.a,self.b,self.c)
end

function Line2D.set_Line2D(self, x, y, linedir)
  self.a = -math.sin(DtoR(linedir)) 
  self.b = math.cos(DtoR(linedir)) 
  self.c = -self.a * x - self.b * y
end

--a取得
function Line2D.get_a(self)
	return self.a
end

--b取得
function Line2D.get_b(self)
	return self.b
end

--c取得
function Line2D.get_c(self)
	return self.c
end

--a設定
function Line2D.set_a(self, a)
	self.a = a
end

--a設定
function Line2D.set_a(self, y1, y2)
	self.a = -(y2 - y1)
end


--b設定
function Line2D.set_b(self, b)
	self.b = b
end

--b設定
function Line2D.set_b(self, x1, x2)
	self.b = (x2 - x1)
end

--c設定
function Line2D.set_c(self, c)
	self.c = c
end

--c設定
function Line2D.set_c(self, x1, y2)
	self.c = -self.a * x1 - self.b * y1
end

function Line2D.dist(self, x, y)
   return math.abs((self.a * x + self.b * y
	 + self.c) / 
		math.sqrt(self.a*self.a + 
			self.b * self.b))
end

function Line2D.dist2(self, x, y)
   local d = self.a * x + self.b * y + self.c
   return (d * d)/ 
		(self.a*self.a + 
			self.b * self.b)
end

function Line2D.intersection(self, line)
   local tmp = self.a * line:get_b() - self.b * line:get_a()
   if(math.abs(tmp) < EPSILON) then return Vector2D:ERROR() end
   line2d_vec:set_vec((self.b * line:get_c() - line:get_b() * self.c)/tmp, 
	(line:get_a() * self.c - self.a * line:get_c())/tmp)
   return line2d_vec
end
