--[[
  ロボカップ用のLuaスクリプト
  止まっているボールに接近する
  bhv_go_to_static_ballをLuaで実装している
]]

--require("luaLib/Geom/Angle2D")
dofile("luaLib/Geom/Angle2D.lua")
--require("luaLib/Geom/Vector2D_o")
dofile("luaLib/Geom/Vector2D_o.lua")

GoToStatic_subtarget = Vector2D.new(0,0)
GoToStatic_p2vec = Vector2D.new(0.0)

function GoToStaticBallMain(ball_place_angle)
   
   local dir_margin = 15.0 --誤差

   angle_diff = normalize(getBallAngle2() - ball_place_angle)
   if (math.abs(angle_diff) < dir_margin
	and getBallDist() < (
		  PlayerSize()
		+ getBallSize() 
		+ 0.08)) then
	--ボール付近にいるため判定不要
	return false
   end

   --サブターゲットの設定
   GoToStatic_p2vec:polar2vector(2.0, ball_place_angle+180.0)
   GoToStatic_subtarget:set_vec(
	getBallPosX() + GoToStatic_p2vec:get_x(), 
	getBallPosY() + GoToStatic_p2vec:get_y())
   --print(GoToStatic_subtarget:get_y())

   local dash_power = 20.0
   local dash_speed = -1.0

   if (getBallDist() > 2.0) then
	dash_power = get_set_play_dash_power()
   else
	dash_speed = PlayerSize()
	dash_power = DashPowerToKeepSpeed(
		dash_speed, getSelfEffort())
   end

   local absdiff = math.abs(angle_diff)
   --print(get_set_play_dash_power())
   --サブターゲットにいく必要があるかどうか
   if(absdiff > dir_margin) then
	Body_GoToPoint(
		GoToStatic_subtarget:get_x(),
		GoToStatic_subtarget:get_y(),
		0.1,
		dash_power,
		dash_speed)
   else
     --体の向きがボールより右側(誤差1.5まで)
     if (math.abs(getBallAngle2() - getSelfBody()) > 1.5) then
	Body_TurnToBall() --ボールに体を向ける
     else
	--ボールまで動く
	doDash(dash_power)
     end
   end

   --フィールドの状態チェック
   Neck_ScanField()
   return true
end
